;============================================
; Strings -- a string finder
;
; To do:
;  o Fix slow listbox behavior (or use other control)
;  o Add menu item or control to allow/disallow spaces
;  o Add control to set minimum/maximum string length
;============================================


	include \masm32\include\masm32rt.inc


;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD
StringsWinProc		PROTO hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
OpenFileDlg		PROTO hWin:HWND, fileOpenNamePtr:DWORD
SaveFileDlg		PROTO hWin:HWND, fileOpenNamePtr:DWORD
strcmp_s		PROTO source:DWORD, dest:DWORD
strcpy_s		PROTO source:DWORD, dest:DWORD
strcat_s		PROTO source:DWORD, dest:DWORD

$mainWindowWidth	EQU 500
$mainWindowHeight	EQU 800

;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN OR WS_VISIBLE
$stringsWinAttrs	EQU WS_CHILD OR WS_VISIBLE OR LBS_HASSTRINGS OR LBS_SORT \
				OR WS_VSCROLL OR LBS_NOSEL OR LBS_DISABLENOSCROLL

;===== Menu items: =====
$menuOpenFile		EQU 1101
$menuWriteStrings	EQU 1102
$menuExit		EQU 1103

;===== String stuff: =====
$minStringLen		EQU 5
$maxStringLen		EQU 40
$stringLenLimit		EQU 200
$ASCIImin		EQU ' '
$ASCIImax		EQU '}'			;Right curly brace

$fileOpenStrLen		EQU 260

;===== Window background colors: =====
$bkRED			EQU 254
$bkGRN			EQU 243
$bkBLUE			EQU 199

$BkColor		EQU $bkRED OR ($bkGRN SHL 8) OR ($bkBLUE SHL 16)

$stringNumThreshold	EQU 100

$stringsFontSize	EQU 16


;============================================
; HERE BE DATA
;============================================
.data

InstanceHandle		HWND ?
MainWinHandle		HWND NULL
StringsWinHandle	HWND ?

ReadFileHandle		HANDLE ?
ReadFileSize		DD ?

StringsFileHandle	HANDLE ?

StringsFontHandle	HFONT ?

HeapHandle		HANDLE ?
HeapPtr			DD ?

NumStrings		DD 0

OldListboxProcPtr	DD ?

AllowSpaces		DW FALSE

MainClassName		DB "StringFinder", 0
StringsClassName	DB "listbox", 0

MainTitleText		DB "StringFinder", 0

FontName		DB "Courier New", 0

FileOpenDlgTitle	DB "Pick file to find strings in:", 0
FileOpenPathStr		DB ".\*.*", 0

FileSaveDlgTitle	DB "Pick file to save strings in:", 0
FileSavePathStr		DB ".\*."
DefaultSaveExt		DB "str", 0

CR_LFtext		DB 13, 10, 0

FileOpenErrMsg		DB "Couldn't open file, sorry.", 0
FileCreateErrMsg	DB "Couldn't create output file.", 0
Readfailmsg		DB "Couldn't read file!", 0
Memfailmsg		DB "Couldn't allocate memory!", 0
NoFileOpenMsg		DB "No file opened. Use File--> open", 0
NoStringsMsg		DB "No strings to write!", 0
ErrorCaption		DB "Error!", 0

;============================================
; CODE LIVES HERE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX

	INVOKE	WinMain, EAX
	INVOKE	ExitProcess, EAX


;====================================================================
; Mainline proc
;====================================================================

WinMain	PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, brush:HBRUSH, wX:DWORD, wY:DWORD, hMenu:HMENU


; Get handle to heap memory to allocate later:
	INVOKE	GetProcessHeap
	MOV	HeapHandle, EAX

; Create  brush to set background color:
	INVOKE	CreateSolidBrush, $BkColor
	MOV	brush, EAX

; Load menu from resource in .exe:
	INVOKE	LoadMenu, hInst, 600		;menu ID
	MOV	hMenu, eax

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWindowProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, brush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
;	INVOKE	LoadIcon, hInst, 500    ; icon ID
;	MOV	wc.hIcon, EAX
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWindowWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWindowHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create our main window:
	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainTitleText,
		$mainWinAttrs, wX, wY, $mainWindowWidth, $mainWindowHeight,
		NULL, hMenu, hInst, NULL
	MOV	MainWinHandle, EAX


;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX				;EAX = 0 = exit
	JZ	exit99
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit99:	INVOKE	DeleteObject, StringsFontHandle
	MOV	EAX, msg.wParam
	RET

WinMain		ENDP


;====================================================================
; Main Window Proc
;====================================================================

MainWindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL gpRect:RECT
		LOCAL fileOpenName[260]:BYTE, scrollInfo:SCROLLINFO
		LOCAL newWidth:DWORD, newHeight:DWORD
		LOCAL buffer[100]:BYTE, numBytesRead:DWORD, fileNamePtr:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_SIZE
	JE	do_size
	CMP	EAX, WM_COMMAND
	JE	do_command
	CMP	EAX, WM_CREATE
	JE	do_create
	CMP	EAX, WM_CLOSE
	JE	do_close

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

;===== case WM_SIZE: =====
do_size:
	INVOKE	GetClientRect, hWin, ADDR gpRect
;	MOVZX	EAX, WORD PTR lParam
;	MOV	newWidth, EAX
;	MOVZX	EAX, WORD PTR lParam + 2
;	MOV	newHeight, EAX
	INVOKE	MoveWindow, StringsWinHandle, 0, 0, gpRect.right, gpRect.bottom, TRUE
;	INVOKE	MoveWindow, StringsWinHandle, 0, 0, newWidth, newHeight, TRUE
	XOR	EAX, EAX
	RET

;===== case WM_COMMAND: =====
do_command:
	MOV	AX, WORD PTR wParam
	CMP	AX, $menuOpenFile
	JE	do_openfile
	CMP	AX, $menuExit
	JE	do_close
	CMP	AX, $menuWriteStrings
	JE	do_write
	JMP	dodefault

;===== case WM_CREATE: =====
do_create:
; Load a fixed-width font for the listbox window:
	INVOKE	CreateFont, $stringsFontSize, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
		ANSI_CHARSET, OUT_DEFAULT_PRECIS,  CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		FIXED_PITCH OR FF_MODERN, ADDR FontName
	MOV	StringsFontHandle, EAX

; Get size of main window:
	INVOKE	GetClientRect, hWin, ADDR gpRect

; Use size to create listbox for strings:
	INVOKE	CreateWindowEx, 0, ADDR StringsClassName, NULL, $stringsWinAttrs, 0,
		0, gpRect.right, gpRect.bottom, hWin, NULL, InstanceHandle, NULL
	MOV	StringsWinHandle, EAX

	INVOKE	SendMessage, EAX, WM_SETFONT, StringsFontHandle, FALSE
; Subclass the listbox control:
	INVOKE	SetWindowLong, StringsWinHandle, GWL_WNDPROC, ADDR StringsWinProc
	MOV	OldListboxProcPtr, EAX

	MOV	HeapPtr, NULL			;Indicate heap hasn't been allocated.
common_exit:
	XOR	EAX, EAX
	RET

;===== case WM_CLOSE: =====
do_close:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

do_openfile:
	INVOKE	OpenFileDlg, hWin, ADDR fileOpenName
; Look at result from GetOpenFileName() to see if user selected a file
; (result will be zero if user cancels, doesn't select a file or an error occurs):
	OR	EAX, EAX
	JZ	open10
open8:	INVOKE	CreateFile, ADDR fileOpenName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL
; See if file open succeeded:
	CMP	EAX, INVALID_HANDLE_VALUE
	JNE	open20
	INVOKE	MessageBox, hWin, ADDR FileOpenErrMsg, ADDR ErrorCaption, MB_OK
open10:	JMP	open90

do_write:
	CALL	WriteStringsToFile
	JMP	common_exit

open20:	MOV	ReadFileHandle, EAX
; Deallocate heap if previously allocated:
	CMP	HeapPtr, NULL
	JE	open25
	INVOKE	HeapFree, HeapHandle, 0, HeapPtr
	MOV	HeapPtr, NULL			;Mark ptr as unused
open25:	INVOKE	GetFileSize, ReadFileHandle, NULL
	MOV	ReadFileSize, EAX
	ADD	EAX, 100			;Pad our allocation.
	INVOKE	HeapAlloc, HeapHandle, 0,  EAX
; Check that memory allocation succeeded:
	OR	EAX, EAX
	JNZ	open30
	INVOKE	MessageBox, hWin, ADDR Memfailmsg, ADDR ErrorCaption, MB_OK
	JMP	SHORT open40

open30:
	MOV	HeapPtr, EAX			;Save pointer to allocated heap
	INVOKE	ReadFile, ReadFileHandle, HeapPtr, ReadFileSize, ADDR numBytesRead, NULL
	OR	EAX, EAX
	JNZ	open35
	INVOKE	MessageBox, hWin, ADDR Readfailmsg, ADDR ErrorCaption, MB_OK
	JMP	SHORT open40

open35:	CALL	FindStrings
	INVOKE	InvalidateRect, StringsWinHandle, NULL, FALSE	;Force repaint.
open40:	INVOKE	CloseHandle, ReadFileHandle
open90:	XOR	EAX, EAX
	RET


MainWindowProc	ENDP


;====================================================================
; String listbox window proc
;
;====================================================================

StringsWinProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL ps:PAINTSTRUCT

dodefault:
	INVOKE	CallWindowProc, OldListboxProcPtr, hWin, uMsg, wParam, lParam
	RET

StringsWinProc	ENDP


;====================================================================
; FindStrings()
;
; ASS-U-MEs that a file has been opened and read into the heap
; (pointed to by HeapPtr). Size of file is in ReadFileSize.
;====================================================================

FindStrings	PROC
		LOCAL stringLen:DWORD, filePtr:DWORD, stringBuffer[$maxStringLen + 4]:BYTE
		LOCAL scanOff:DWORD, count:DWORD

	INVOKE	SendMessage, StringsWinHandle, WM_SETREDRAW, 0, 0

; Clear any previous items from listbox:
	INVOKE	SendMessage, StringsWinHandle, LB_RESETCONTENT, 0, 0

; Find out how many strings there are:
	CALL	CountStrings
	MOV	NumStrings, EAX
	CMP	EAX, $stringNumThreshold
	JB	@F
; Allocate storage for strings (# strings/# bytes):
	INVOKE	SendMessage, StringsWinHandle, LB_INITSTORAGE, EAX, EDX
@@:	PUSH	ESI
	PUSH	EDI
	MOV	ESI, HeapPtr
	MOV	EAX, ReadFileSize
	MOV	count, EAX
fs5:	LEA	EDI, stringBuffer
	MOV	stringLen, 0
	MOV	scanOff, FALSE
fs10:	DEC	count
	JZ	fs_EOF
	LODSB					;GNC
; Exclude non-ASCII characters from string:
	CMP	AL, $ASCIImin
	JB	fs20
	CMP	AL, $ASCIImax
	JA	fs20
; If char is space, check AllowSpaces flag:
	CMP	AL, ' '
	JNE	@F
	CMP	AllowSpaces, TRUE
	JNE	fs20
@@:	CMP	scanOff, TRUE			;Are we scanning off a string?
	JE	fs10				;  Yep, get next char.
	CMP	stringLen, $maxStringLen
	JE	fs30
	INC	stringLen
	STOSB
	JMP	fs10

; Max. string length hit, so we must output string and scan the remainder off:
fs30:	MOV	BYTE PTR [EDI], 0		;Make ASCIIZ.
	INVOKE	SendMessage, StringsWinHandle, LB_ADDSTRING, 0, ADDR stringBuffer
	MOV	scanOff, TRUE
	JMP	fs10

; Non-ASCII char seen: is there a string to output?
fs20:	CMP	stringLen, $minStringLen
	JB	fs5				;No, keep scanning.
; Output string to listbox:
	MOV	BYTE PTR [EDI], 0		;Make ASCIIZ.
	INVOKE	SendMessage, StringsWinHandle, LB_ADDSTRING, 0, ADDR stringBuffer
	JMP	fs5				;Reset, keep scanning.

fs_EOF:	CMP	stringLen, $minStringLen
	JB	fs99
	MOV	BYTE PTR [EDI], 0		;Make ASCIIZ.
	INVOKE	SendMessage, StringsWinHandle, LB_ADDSTRING, 0, ADDR stringBuffer

fs99:	INVOKE	SendMessage, StringsWinHandle, WM_SETREDRAW, 1, 0
	POP	EDI
	POP	ESI
	RET

FindStrings	ENDP


;====================================================================
; CountStrings()
;
; Counts the number of strings in the file so listbox memory can be
; allocated. Doesn't actually do anything with the strings.
;
; ASS-U-MEs that a file has been opened and read into the heap
; (pointed to by HeapPtr). Size of file is in ReadFileSize.
;
; Returns:
;	EAX: # of strings
;	EDX: total length of strings
;====================================================================

CountStrings	PROC
		LOCAL stringLen:DWORD, stringCount:DWORD
		LOCAL scanOff:DWORD, count:DWORD

	MOV	EAX, ReadFileSize
	MOV	count, EAX
	MOV	stringCount, 0
	MOV	ECX, HeapPtr			;ECX is read ptr.
	XOR	EDX, EDX			;EDX = total string length.
cs5:	MOV	stringLen, 0
	MOV	scanOff, FALSE
cs10:	DEC	count
	JZ	cs_EOF
	MOV	AL, BYTE PTR [ECX]		;GNC
	INC	ECX	

; Exclude non-ASCII characters from string:
	CMP	AL, $ASCIImin
	JB	cs20
	CMP	AL, $ASCIImax
	JA	cs20

; If char is space, check AllowSpaces flag:
	CMP	AL, ' '
	JNE	@F
	CMP	AllowSpaces, TRUE
	JNE	cs20
@@:	CMP	scanOff, TRUE			;Are we scanning off a string?
	JE	cs10				;  Yep, get next char.
	CMP	stringLen, $maxStringLen
	JE	cs30
	INC	stringLen
	JMP	cs10

; Max. string length hit, so we must count string and scan the remainder off:
cs30:	INC	stringCount
	ADD	EDX, stringLen
	MOV	scanOff, TRUE
	JMP	cs10

; Non-ASCII char seen: is there a string to output?
cs20:	CMP	stringLen, $minStringLen
	JB	cs5				;No, keep scanning.
; Count string:
	INC	stringCount
	ADD	EDX, stringLen
	JMP	cs5				;Reset, keep scanning.

cs_EOF:	CMP	stringLen, $minStringLen
	JB	cs99
	INC	stringCount
	ADD	EDX, stringLen

cs99:	MOV	EAX, stringCount
	RET

CountStrings	ENDP


;=====================================================
; WriteStringsToFile()
;
;=====================================================

WriteStringsToFile	PROC
			LOCAL writeFileHandle:HANDLE, dummy:DWORD
			LOCAL count:DWORD, index:DWORD, fileSaveName[260]:BYTE
			LOCAL stringBuffer[$stringLenLimit + 4]:BYTE
			LOCAL prevString[$stringLenLimit + 4]:BYTE

	CMP	HeapPtr, NULL
	JNE	@F
	INVOKE	MessageBox, 0, ADDR NoFileOpenMsg, ADDR ErrorCaption, MB_OK
	RET

@@:	CMP	NumStrings, 0
	JNE	@F
	INVOKE	MessageBox, 0, ADDR NoStringsMsg, ADDR ErrorCaption, MB_OK
	RET

@@:	INVOKE	SaveFileDlg, MainWinHandle, ADDR fileSaveName
	OR	EAX, EAX
	JZ	ws99
open8:	INVOKE	CreateFile, ADDR fileSaveName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL, NULL
; See if file create succeeded:
	CMP	EAX, INVALID_HANDLE_VALUE
	JNE	@F
	INVOKE	MessageBox, 0, ADDR FileCreateErrMsg, ADDR ErrorCaption, MB_OK
	RET
@@:	MOV	writeFileHandle, EAX

	MOV	prevString[0], 0		;NULL out previous string.
	MOV	index, 0
	MOV	EAX, NumStrings
	MOV	count, EAX

; Loop through listbox entries:
ws15:	INVOKE	SendMessage, StringsWinHandle, LB_GETTEXT, index, ADDR stringBuffer
	INVOKE	strcmp_s, ADDR stringBuffer, ADDR prevString
	OR	EAX, EAX
	JNZ	ws30				;Match, so get next string from listbox.

; Copy this string to previous string buffer:
ws20:	INVOKE	strcpy_s, ADDR stringBuffer, ADDR prevString

; Append CR/LF, write string to file:
	INVOKE	strcat_s, ADDR CR_LFtext, ADDR stringBuffer
	LEA	EAX, stringBuffer
	CALL	strlen
	MOV	EDX, EAX
	INVOKE	WriteFile, writeFileHandle, ADDR stringBuffer, EDX, ADDR dummy, NULL
ws30:	INC	index
	DEC	count
	JNZ	ws15

	INVOKE	CloseHandle, writeFileHandle
ws99:	RET

WriteStringsToFile	ENDP


;=====================================================
; OpenFileDlg (hWin, fileOpenNamePtr)
;
; Basically a wrapper for GetOpenFileName()
; Sets up needed structure, invokes file-selection
; dialog.
;
; On exit,
;   EAX = return value (zero if user cancelled or
;	selected no file)
;=====================================================

OpenFileDlg	PROC	hWin:HWND, fileOpenNamePtr:DWORD
	LOCAL	ofn:OPENFILENAME

; First, zero out entire structure:
	PUSH	EDI
	LEA	EDI, ofn
	MOV	ECX, SIZEOF OPENFILENAME
	XOR	EAX, EAX
	REP	STOSB					;Zero it out.
	POP	EDI

	MOV	ofn.lStructSize, SIZEOF OPENFILENAME
	MOV	EAX, hWin
	MOV	ofn.hWndOwner, EAX
	MOV	EAX, InstanceHandle
	MOV	ofn.hInstance, EAX
	MOV	EAX, fileOpenNamePtr
	MOV	ofn.lpstrFile, EAX
	INVOKE	strcpy_s, OFFSET FileOpenPathStr, EAX
	MOV	ofn.nMaxFile, $fileOpenStrLen
	MOV	ofn.lpstrTitle, OFFSET FileOpenDlgTitle
	MOV	ofn.Flags, OFN_FILEMUSTEXIST OR OFN_LONGNAMES OR OFN_HIDEREADONLY
	INVOKE	GetOpenFileName, ADDR ofn
	RET

OpenFileDlg	ENDP


;=====================================================
; SaveFileDlg (hWin, fileOpenNamePtr)
;
; Basically a wrapper for GetSaveFileName()
; Sets up needed structure, invokes file-selection
; dialog.
;
; On exit,
;   EAX = return value (zero if user cancelled or
;	selected no file)
;=====================================================

SaveFileDlg	PROC	hWin:HWND, fileSaveNamePtr:DWORD
	LOCAL	ofn:OPENFILENAME

; First, zero out entire structure:
	PUSH	EDI
	LEA	EDI, ofn
	MOV	ECX, SIZEOF OPENFILENAME
	XOR	EAX, EAX
	REP	STOSB					;Zero it out.
	POP	EDI

	MOV	ofn.lStructSize, SIZEOF OPENFILENAME
	MOV	EAX, hWin
	MOV	ofn.hWndOwner, EAX
	MOV	EAX, InstanceHandle
	MOV	ofn.hInstance, EAX
	MOV	EAX, fileSaveNamePtr
	MOV	ofn.lpstrFile, EAX
	INVOKE	strcpy_s, OFFSET FileSavePathStr, EAX
	MOV	ofn.nMaxFile, $fileOpenStrLen
	MOV	ofn.lpstrTitle, OFFSET FileSaveDlgTitle
	MOV	ofn.lpstrDefExt, OFFSET DefaultSaveExt
	MOV	ofn.Flags, OFN_LONGNAMES OR OFN_HIDEREADONLY OR OFN_OVERWRITEPROMPT
	INVOKE	GetSaveFileName, ADDR ofn
	RET

SaveFileDlg	ENDP


;====================================================================
; strcpy()
;====================================================================

strcpy		PROC

scp10:	LODSB
	STOSB
	OR	AL, AL			;Stop on NULL.
	JNZ	scp10
	RET

strcpy		ENDP


;====================================================================
; strcpy_s (source, dest)
;====================================================================

strcpy_s	PROC source:DWORD, dest:DWORD

	PUSH	ESI
	PUSH	EDI
	MOV	ESI, source
	MOV	EDI, dest

scp10:	LODSB
	STOSB
	OR	AL, AL			;Stop on NULL.
	JNZ	scp10

scp99:	POP	EDI
	POP	ESI
	RET

strcpy_s	ENDP


;====================================================================
; strlen()
;
; On entry,
;   EAX--> string to be measured
;====================================================================

strlen		PROC

	XOR	EDX, EDX			;Len. counter
sl10:	CMP	BYTE PTR [EAX], NULL
	JE	sl88
	INC	EDX
	INC	EAX
	JMP	sl10	
sl88:	MOV	EAX, EDX
	RET

strlen		ENDP


;============================================
; strcmp_s (source, dest)
;
; Case-sensitive string comparator
;
; On exit,
;   EAX = result of comparison
;   (FALSE = no match, anything else = match)
;============================================

strcmp_s	PROC source:DWORD, dest:DWORD

	PUSH	ESI
	PUSH	EDI
	MOV	ESI, source
	MOV	EDI, dest
scmp0:	LODSB				;One byte in AL,
	MOV	AH, BYTE PTR [EDI]	;  other in AH.
	INC	EDI
	OR	AX, AX			;If both zero,
	JZ	scmp8			;  we have a match.
	OR	AL, AL			;If only one is zero,
	JZ	scmp7			;  no match.
	OR	AH, AH
	JZ	scmp7
; Nonzero characters--compare:
	CMP	AL, AH			;If chars. match,
	JE	scmp0			;  keep on truckin'.

scmp7:	XOR	EAX, EAX		;No match, return FALSE.
scmpX:	POP	EDI
	POP	ESI
	RET

scmp8:	MOV	EAX, TRUE
	JMP	scmpX	

strcmp_s	ENDP


;====================================================================
; strcat_s (source, dest)
;
;====================================================================

strcat_s	PROC source:DWORD, dest:DWORD

	PUSH	ESI
	PUSH	EDI
	MOV	ESI, source
	MOV	EDI, dest

; Locate end of destination buffer:
scat10:	MOV	AL, BYTE PTR [EDI]
	OR	AL, AL			;Look for NULL terminator.
	JE	scat20
	LEA	EDI, [EDI + 1]
	JMP	scat10
scat20:	CALL	strcpy
	POP	EDI
	POP	ESI
	RET

strcat_s	ENDP


;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP


	END	start

